double nuclear_charge = 10.0;
double n_c=0.0, n_r=1.0, phi=0.0, w=1.0, E_0=0.0;
double duration; // will be assigned when vecpot_z is called

//
// Functions
//

double vecpot_ramping(double time)
{
  double result, ampl, ramping, constperiod, downramp, T;
  result = 0.0;
  ampl   = E_0 / w;

  T = 2 * M_PI / w;

  constperiod = n_c * T;
  ramping     = n_r * T;
  downramp    = ramping;
  
  duration = ramping + downramp + constperiod;

  if (time>0)
    {

      if (time<ramping){
	result=-ampl/ramping*time*cos(w*time) + ampl/(w*ramping)*sin(w*time);}
      
      if ( (time>=ramping)&&(time<ramping+constperiod))
	result=-ampl*cos(w*time);
      
      if ( (time >= ramping+constperiod) && (time < ramping+constperiod+downramp)) 
	{  result=ampl/downramp*(time-downramp-constperiod-ramping)*
	     cos(w*time)-ampl/(w*downramp)*sin(w*time);
	}
      
      if ( time > ramping+constperiod+downramp ) result=0.0;
    };

  return result;
}  


//
double vecpot_x(double time, int me)
{
  return 0.0;
}  

//
double vecpot_y(double time, int me)
{
   return 0.0;
}  


double vecpot_z(double time, int me)
{
  return vecpot_ramping(time);
// return 0.0;
}



double scalarpotx(double x, double y, double z, double time, int me)
{  

  double result=-nuclear_charge/x;
  return result;
}



double scalarpoty(double x, double y, double z, double time, int me)
{
  double result=0.0;  
  return result;
}


double scalarpotz(double x, double y, double z, double time, int me)
{
  double result=0.0;
  return result;
}
  

double field(double time, int me)
{
  double result=0.0;
  return result;
}  


double imagpot(long xindex, long yindex, long zindex, double time, grid g)
{
  double x,y,z;
  double ampl=0.0;


  if (ampl>1.0)
    {
      x=((double) xindex + 0.5  - 0.5*g.ngps_x())/(0.5*g.ngps_x())
	*((double) xindex + 0.5  - 0.5*g.ngps_x())/(0.5*g.ngps_x());
      
      switch(g.dimens())
	{
	case 3 : 
	  y=((double) yindex + 0.5  - 0.5*g.ngps_y())/(0.5*g.ngps_y())
	    *((double) yindex + 0.5  - 0.5*g.ngps_y())/(0.5*g.ngps_y());
	  z=((double) zindex + 0.5  - 0.5*g.ngps_z())/(0.5*g.ngps_z())
	    *((double) zindex + 0.5  - 0.5*g.ngps_z())/(0.5*g.ngps_z());
	  return ampl*(x*x*x*x*x*x*x*x+y*y*y*y*y*y*y*y+z*z*z*z*z*z*z*z);
	  break;
	  
	case 2 : case 6 :
	  y=((double) yindex + 0.5  - 0.5*g.ngps_y())/(0.5*g.ngps_y())
	    *((double) yindex + 0.5  - 0.5*g.ngps_y())/(0.5*g.ngps_y());
	  return ampl*(x*x*x*x*x*x*x*x+y*y*y*y*y*y*y*y);
	  break;
	  
	case 1 : case 5 : case 15 :
	  return ampl*(x*x*x*x*x*x*x*x);
	  break;
	  
	case 4 : case 14 : case 24 : case 34 :		
	  x=((double) xindex + 0.5  )/(g.ngps_x())
	    *((double) xindex + 0.5  )/(g.ngps_x());
	  return ampl*(x*x*x*x*x*x*x*x);
	  break;
	  
	default : return 0.0;
	}
    }
  else
    {
      return 0.0;
    };
      
}  
